package com.yice.webadmin.app.controller;

import cn.hutool.core.util.BooleanUtil;
import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.dto.DatasetManageDto;
import com.yice.webadmin.app.dto.DatasetVersionDto;
import com.yice.webadmin.app.model.DatasetManage;
import com.yice.webadmin.app.model.DatasetVersion;
import com.yice.webadmin.app.service.DatasetManageService;
import com.yice.webadmin.app.vo.DatasetManageVo;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 数据集管理操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "数据集管理管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/datasetManage")
public class DatasetManageController {

    @Autowired
    private DatasetManageService datasetManageService;

    /**
     * 新增数据集管理数据。
     *
     * @param datasetManageDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"datasetManageDto.datasetId", "datasetManageDto.searchString"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody DatasetManageDto datasetManageDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetManageDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetManage datasetManage = MyModelUtil.copyTo(datasetManageDto, DatasetManage.class);
        datasetManage = datasetManageService.saveAndCreateVersion(datasetManage);
        return ResponseResult.success(datasetManage.getDatasetId());
    }

    /**
     * 更新数据集管理数据。
     *
     * @param datasetManageDto 更新对象。
     * @return 应答结果对象。
     */
    @ApiOperationSupport(ignoreParameters = {"datasetManageDto.searchString"})
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody DatasetManageDto datasetManageDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetManageDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetManage datasetManage = MyModelUtil.copyTo(datasetManageDto, DatasetManage.class);
        DatasetManage originalDatasetManage = datasetManageService.getById(datasetManage.getDatasetId());
        if (originalDatasetManage == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetManageService.update(datasetManage, originalDatasetManage)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除数据集管理数据。
     *
     * @param datasetId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long datasetId) {
        if (MyCommonUtil.existBlankArgument(datasetId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(datasetId);
    }

    /**
     * 列出符合过滤条件的数据集管理列表。
     *
     * @param datasetManageDtoFilter  过滤对象。
     * @param datasetVersionDtoFilter 一对多从表过滤对象。
     * @param orderParam              排序参数。
     * @param pageParam               分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<DatasetManageVo>> list(
            @MyRequestBody DatasetManageDto datasetManageDtoFilter,
            @MyRequestBody DatasetVersionDto datasetVersionDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetManage datasetManageFilter = MyModelUtil.copyTo(datasetManageDtoFilter, DatasetManage.class);
        DatasetVersion datasetVersionFilter = MyModelUtil.copyTo(datasetVersionDtoFilter, DatasetVersion.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, DatasetManage.class);
        List<DatasetManage> datasetManageList =
                datasetManageService.getDatasetManageListWithRelation(datasetManageFilter, datasetVersionFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(datasetManageList, DatasetManage.INSTANCE));
    }

    /**
     * 查询所有数据集列表最新的记录列表进行分组查询。
     *
     * @param datasetManageDtoFilter  过滤对象。
     * @param orderParam              排序参数。
     * @param pageParam               分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/findDatasets")
    public ResponseResult<MyPageData<DatasetManageVo>> findDatasets(
            @MyRequestBody DatasetManageDto datasetManageDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetManage datasetManageFilter = MyModelUtil.copyTo(datasetManageDtoFilter, DatasetManage.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, DatasetManage.class);
        //查询我的数据集，如果是管理员可以查询所有，否则只能查看自己
        TokenData tokenData = TokenData.takeFromRequest();
        datasetManageFilter.setCreateUserId(BooleanUtil.isTrue(tokenData.getIsAdmin()) ? null : tokenData.getUserId());
        List<DatasetManage> datasetManageList =
                datasetManageService.getDatasetManageGroupList(datasetManageFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(datasetManageList, DatasetManage.INSTANCE));
    }

    /**
     * 列出符合过滤条件的数据集管理列表。
     *
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/listForTree")
    public ResponseResult<List<DatasetManageVo>> listForTree() {
        List<DatasetManage> datasetManageList =
                datasetManageService.getDatasetManageListWithRelation(new DatasetManage(), new DatasetVersion(), "");
        return ResponseResult.success(DatasetManage.INSTANCE.fromModelList(datasetManageList));
    }

    /**
     * 查看指定数据集管理对象详情。
     *
     * @param datasetId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<DatasetManageVo> view(@RequestParam Long datasetId) {
        DatasetManage datasetManage = datasetManageService.getByIdWithRelation(datasetId, MyRelationParam.full());
        if (datasetManage == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        DatasetManageVo datasetManageVo = DatasetManage.INSTANCE.fromModel(datasetManage);
        return ResponseResult.success(datasetManageVo);
    }

    private ResponseResult<Void> doDelete(Long datasetId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        DatasetManage originalDatasetManage = datasetManageService.getById(datasetId);
        if (originalDatasetManage == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetManageService.remove(datasetId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
